/*
 * 创客收货地址
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class UserAddressController : BaseController
    {
        public UserAddressController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 创客收货地址列表

        /// <summary>
        /// 根据条件查询创客收货地址列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(UserAddress data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.UserId = data.UserId.ToString();

            string Condition = "";
            Condition += "Address:\"" + data.Address + "\",";
            Condition += "PostalCode:\"" + data.PostalCode + "\",";
            Condition += "RealName:\"" + data.RealName + "\",";
            Condition += "Mobile:\"" + data.Mobile + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询创客收货地址列表

        /// <summary>
        /// 创客收货地址列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(UserAddress data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Address", "2"); //详细地址
            Fields.Add("PostalCode", "2"); //邮政编码
            Fields.Add("RealName", "2"); //收货人姓名
            Fields.Add("Mobile", "2"); //手机号码
            Fields.Add("UserId", "1");

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserAddress", Fields, "Id desc", "False", page, limit);
            
            return Json(obj);
        }

        #endregion

        #region 增加创客收货地址

        /// <summary>
        /// 增加或修改创客收货地址信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string UserId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.UserId = UserId;

            return View();
        }

        #endregion

        #region 增加创客收货地址

        /// <summary>
        /// 增加或修改创客收货地址信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(UserAddress data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("UserId", data.UserId);
            Fields.Add("Address", data.Address); //详细地址
            Fields.Add("PostalCode", data.PostalCode); //邮政编码
            Fields.Add("RealName", data.RealName); //收货人姓名
            Fields.Add("Mobile", data.Mobile); //手机号码
            Fields.Add("Areas", data.Areas); //所在地区
            Fields.Add("IsDefault", data.IsDefault); //是否默认

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("UserAddress", Fields, 0);
            AddSysLog(data.Id.ToString(), "UserAddress", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改创客收货地址

        /// <summary>
        /// 增加或修改创客收货地址信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string UserId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.UserId = UserId;

            UserAddress editData = db.UserAddress.FirstOrDefault(m => m.Id == Id) ?? new UserAddress();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改创客收货地址

        /// <summary>
        /// 增加或修改创客收货地址信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(UserAddress data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Address", data.Address); //详细地址
            Fields.Add("PostalCode", data.PostalCode); //邮政编码
            Fields.Add("RealName", data.RealName); //收货人姓名
            Fields.Add("Mobile", data.Mobile); //手机号码
            Fields.Add("Areas", data.Areas); //所在地区
            Fields.Add("IsDefault", data.IsDefault); //是否默认

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserAddress", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "UserAddress", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除创客收货地址信息

        /// <summary>
        /// 删除创客收货地址信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserAddress", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("UserAddress", id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserAddress", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserAddress", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "UserAddress", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("UserAddress", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("UserAddress", Sort, Id);

            AddSysLog(Id.ToString(), "UserAddress", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.UserAddress.Add(new UserAddress()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "UserAddress", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(UserAddress data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Address", "2"); //详细地址
            Fields.Add("PostalCode", "2"); //邮政编码
            Fields.Add("RealName", "2"); //收货人姓名
            Fields.Add("Mobile", "2"); //手机号码

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("UserAddress", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "UserAddress", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
